"""
Django settings for dossieraid project.

Generated by 'django-admin startproject' using Django 2.0.2.

For more information on this file, see
https://docs.djangoproject.com/en/2.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.0/ref/settings/
"""

import os
import dj_database_url
# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.environ.get('SECRET_KEY','4apj(xg#z&whn06h=^p)87!eu2bovmzuy)xkrr=nfzu6rn@bke')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = os.environ.get('DEBUG', 'False') == 'True'
if DEBUG:
    ALLOWED_HOSTS = os.environ.get('HOST', '*').split(',')
    EMAIL_BACKEND = 'django.core.mail.backends.console.EmailBackend'
else:
    ALLOWED_HOSTS = os.environ.get('HOST', 'localhost').split(',')
    EMAIL_BACKEND = "anymail.backends.mailgun.EmailBackend"

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'gestion',
    #'materializecssform',
    'material',
    'sendfile',
    "anymail",
    #'material.frontend',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'dossieraid.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [
            os.path.join(BASE_DIR, 'gestion/templates'),
            os.path.join(BASE_DIR, 'dossieraid/registration'),
            os.path.join(BASE_DIR, 'orga/templates'),
        ],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'dossieraid.wsgi.application'


# Database
# https://docs.djangoproject.com/en/2.0/ref/settings/#databases

DATABASES = {
    'default': dj_database_url.config(default='sqlite:///' + os.path.join(BASE_DIR, 'db.sqlite3'))
}


# Password validation
# https://docs.djangoproject.com/en/2.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/2.0/topics/i18n/

LANGUAGE_CODE = 'fr-fr'

TIME_ZONE = 'Europe/Paris' # Paname, paname

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.0/howto/static-files/
STATIC_ROOT = '/app/staticfiles'
#STATIC_ROOT = os.path.join(BASE_DIR, "staticfiles")
STATIC_URL = '/static/'
MEDIA_ROOT = '.'
MEDIA_URL = '/media/' #nécessaire pour upload des fichiers
LOGIN_REDIRECT_URL = '/'
LOGOUT_REDIRECT_URL = '/'

#
ANYMAIL = {
    # (exact settings here depend on your ESP...)
    "MAILGUN_API_KEY": os.environ.get('MAILGUN_API_KEY', ''),
    "MAILGUN_SENDER_DOMAIN": os.environ.get('MAILGUN_DOMAIN', 'demo'),  # your Mailgun domain, if needed
}
DEFAULT_FROM_EMAIL = os.environ.get('DEFAULT_FROM_EMAIL', 'billetterie@raid.bde-insa-lyon.fr')




VALID_FILE_TYPES = ['application/pdf', 'image/png', 'image/jpeg', 'image/gif']

BILLEVENT_API_URL = os.environ.get('BILLEVENT_API_URL', 'https://api.billetterie.test.bde-insa-lyon.fr/')
BILLEVENT_API_USERNAME = os.environ.get('BILLEVENT_API_USERNAME', 'aprats')
BILLEVENT_API_PASSWORD = os.environ.get('BILLEVENT_API_PASSWORD', 'aprats')

BILLEVENT_RAID_EVENT = int(os.environ.get('BILLEVENT_RAID_EVENT', 2))  # ID de l'évènement sur lequel créer les invitations
BILLEVENT_PRIX_NORMAL = int(os.environ.get('BILLEVENT_PRIX_NORMAL', 14)) # 'prixNormal' dans le code
BILLEVENT_PRIX_ETUDIANT = int(os.environ.get('BILLEVENT_PRIX_ETUDIANT', 15)) # 'prixEdu' dans le code
BILLEVENT_PRIX_VA = int(os.environ.get('BILLEVENT_PRIX_VA', 13))       # 'prixVA' dans le code

BILLEVENT_PRIX = {"prixNormal":BILLEVENT_PRIX_NORMAL,
                  "prixEdu": BILLEVENT_PRIX_ETUDIANT,
                  "prixVA": BILLEVENT_PRIX_VA }


ADHESION = {
    'URL': os.environ.get('ADHESION_URL', "https://api.adhesion2.test.bde-insa-lyon.fr"),
    'CLIENT_ID': os.environ.get('ADHESION_CLIENT_ID', "0wggUlfKYGCP2wFc3kgbXvomK6kRdq8RHvoedAvp"),
    'CLIENT_SECRET': os.environ.get('ADHESION_CLIENT_SECRET', "GnJHQur2acsE3zfKRd57DmnDxJGoR2EASpDbLAM5ZBVq6GGbJgOEQwcdWKatfkNrfpRr8l343oaA0r3SqpCgfpCJJIpUOgmQbmBhfvgnGXoHn48Fda9AMsL0HrHH4q8N")
}

FRONTEND_PERMANENCIER_URL = os.environ.get('FRONTEND_PERMANENCIER_URL', 'https://permanencier.billetterie.test.bde-insa-lyon.fr/')
#ça permet avec 2-3 bouts de code de sécuriser et déléguer le téléchargement des fichiers

SENDFILE_BACKEND = 'sendfile.backends.development'
SENDFILE_ROOT = BASE_DIR
SENDFILE_URL = '/media/'

#Logging
ADMINS = [('Équipe OrgaIF', os.getenv('ADMIN_EMAIL', 'dev@yopmail.com')) ]
SERVER_EMAIL = os.getenv('SERVER_EMAIL', 'logs@yopmail.com')
LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'handlers': {
        'console': {
            'class': 'logging.StreamHandler',
        },
        'mail_admins_debug': {
            'level': 'ERROR',
            'class': 'django.utils.log.AdminEmailHandler',
            'include_html': True,
        }
    },
    'loggers': {
        'talkapi': {
            'handlers': ['console'],
           # 'handlers': ['console', 'mail_admins_debug'],
            'level': 'ERROR'
        },
    },
}
EMAIL_SUBJECT_PREFIX = '[CourirLeRAID] '
